﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net;

namespace Úkol
{
    public partial class Form1 : Form
    {
        bool nastaveno = false;
        Form2 vypis;
        string[] pole = new string[20];

        PictureBox[,] policko = new PictureBox[20, 20];

        long IdentifikacniCisloHry = 0;
        int PoziceLerakaX = 0;
        int PoziceLerakaY = 0;  //Ne, nechci Point
        char SmerLeraka = 'X';

        Label[] kartaD = new Label[9];
        Label[] kartaZ = new Label[5];
        int volnaKarta = 0;
        byte[] zvolenaKarta = new byte[9];

        Label[] budLerak = new Label[5];

        public Form1()
        {
            InitializeComponent();
            initializujKarty();
            initializujBudouciLeraky();
        }

        private List<string> request(string subadresa)
        {
            List<string> vysledek = new List<string>();
            try
            {
            Uri u = new Uri(textBox1.Text + "/" + subadresa);
            HttpWebRequest req = (HttpWebRequest)WebRequest.Create(u);

            if (checkBox1.Checked)
            {
                WebProxy prox = new WebProxy("hostname", 80);
                prox.BypassProxyOnLocal = true;
                req.Proxy = prox;
            }

            if (checkBox3.Checked)
            {
                req.Credentials = new NetworkCredential(textBox4.Text, textBox5.Text);
            }

            req.Accept = "*/*";
            req.AllowAutoRedirect = checkBox2.Checked;
            req.Timeout = (int)(numericUpDown2.Value * 1000);
            if (checkBox4.Checked) req.UserAgent = textBox3.Text;
            req.Method = "GET";

            HttpWebResponse resp = (HttpWebResponse)req.GetResponse();
            StreamReader sr = new StreamReader(resp.GetResponseStream());
            string line = "";
            while (line != null)
            {
                line = sr.ReadLine();
                vysledek.Add(line);
            }
            resp.Close();
            }
            catch (Exception exc)
            {
                MessageBox.Show("Došlo k chybě při připojování k serveru.\n" + exc.ToString(), "Chyba", MessageBoxButtons.OK,MessageBoxIcon.Error );
            }

            vypis.txt.Text = "";
            foreach (string s in vysledek) vypis.txt.Text += s + "\r\n";
            return vysledek;
        }

        private void zacatekHry()
        {
            button3.Hide();
            hraciPlocha.Show();
            menu.Show();
            List<string> sr = request("start");
            IdentifikacniCisloHry = Convert.ToInt64(sr[0]);
            lID.Text = IdentifikacniCisloHry.ToString();
            for (int i = 0; i <= 19; i++)
            {
                pole[i] = sr[i + 1];
                for (int s = 0; s <= 19; s++)
                {
                    char ch = pole[i][s];

                    policko[i, s] = new PictureBox();
                    policko[i, s].Location = new Point(s * 20, i * 20);
                    policko[i, s].Size = new Size(20, 20);
                    policko[i, s].BorderStyle = BorderStyle.Fixed3D;
                    if (ch == 'X') policko[i, s].BackColor = Color.Brown;
                    else
                        if (ch == '#') policko[i, s].BackColor = Color.Black;
                        else
                            if (ch == '$') policko[i, s].BackColor = Color.Yellow;
                            else
                                policko[i, s].BackColor = Color.White;
                    policko[i, s].Parent = hraciPlocha;
                    policko[i, s].CreateControl();
                }
            }
            string poz = sr[21];
            string pozX = poz.Substring(0, poz.IndexOf(' '));
            PoziceLerakaX = Convert.ToInt16(pozX);
            lX.Text = pozX;
            poz = poz.Substring(poz.IndexOf(' ') + 1);
            string pozY = poz.Substring(0, poz.IndexOf(' '));
            PoziceLerakaY = Convert.ToInt16(pozY);
            lY.Text = pozY;
            poz = poz.Substring(poz.IndexOf(' ') + 1);
            SmerLeraka = poz[0];
            lSmer.Text = poz[0].ToString();

            vykresliLeraka();
            lerak.Show();
            lerak.BringToFront();

            string pasKaret = sr[22];
            for (int i = 0; i <= 8; i++)
            {
                kartaD[i].Text = pasKaret[i].ToString();
            }
        }

        private void dalsiTah()
        {
            string pohyby = "";
            for (int i = 0; i <= 4; i++)
            {
                pohyby += kartaZ[i].Text;
                kartaZ[i].Text = "?";
                kartaZ[i].BackColor = Color.FromArgb(192, 192, 255);
                budLerak[i].Hide();
            }
            List<string> sr = request("kolo?id=" + IdentifikacniCisloHry + "&pohyby=" + pohyby);

            string poz = sr[21];
            string pozX = poz.Substring(0, poz.IndexOf(' '));
            PoziceLerakaX = Convert.ToInt16(pozX);
            lX.Text = pozX;
            poz = poz.Substring(poz.IndexOf(' ') + 1);
            string pozY = poz.Substring(0, poz.IndexOf(' '));
            PoziceLerakaY = Convert.ToInt16(pozY);
            lY.Text = pozY;
            poz = poz.Substring(poz.IndexOf(' ') + 1);
            SmerLeraka = poz[0];
            lSmer.Text = poz[0].ToString();

            vykresliLeraka();
            lerak.Show();
            lerak.BringToFront();

            string pasKaret = sr[22];
            for (int i = 0; i <= 8; i++)
            {
                kartaD[i].Text = pasKaret[i].ToString();
                kartaD[i].BackColor = Color.FromArgb(128, 255, 128);
            }

            volnaKarta = 0;
        }

        private void initializujBudouciLeraky()
        {
            budLerak[0] = budouci1;
            budLerak[1] = budouci2;
            budLerak[2] = budouci3;
            budLerak[3] = budouci4;
            budLerak[4] = budouci5;
        }

        private void initializujKarty()
        {
            kartaD[0] = dp1;
            kartaD[1] = dp2;
            kartaD[2] = dp3;
            kartaD[3] = dp4;
            kartaD[4] = dp5;
            kartaD[5] = dp6;
            kartaD[6] = dp7;
            kartaD[7] = dp8;
            kartaD[8] = dp9;

            kartaZ[0] = zp1;
            kartaZ[1] = zp2;
            kartaZ[2] = zp3;
            kartaZ[3] = zp4;
            kartaZ[4] = zp5;
        }

        private void vykresliLeraka()
        {
            lerak.Location = new Point((PoziceLerakaX - 1) * 20 + 3, (PoziceLerakaY - 1) * 20 + 3);
            if (SmerLeraka == 'N') lerak.Text = "^";
            if (SmerLeraka == 'D') lerak.Text = "v";
            if (SmerLeraka == 'R') lerak.Text = ">";
            if (SmerLeraka == 'L') lerak.Text = "<";
        }

        private void tabControl1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (!nastaveno && tabControl1.SelectedIndex != 0)
            {
                tabControl1.SelectedIndex = 0;
                MessageBox.Show("Nejprve uložte nastavení!", "Ale notak...", MessageBoxButtons.OK, MessageBoxIcon.Stop);
            }
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            panel1.Enabled = false;
            nastaveno = true;
            MessageBox.Show("Nyní se odemčely záložky \"Interaktivní hra uživatele\" a \"Počítačová inteligence\".", "Informace", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void button2_Click_1(object sender, EventArgs e)
        {
            MessageBox.Show("Pro standardní běh aplikace v soutěžních podmínkách není třeba nic měnit.\nUser agenta, proxy ani autorizaci není třeba nastavovat.\nJen to prostě nechte tak jak to je a klikněte na \"Použít nastavení a hrát\".", "Readme", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void checkBox1_CheckedChanged_1(object sender, EventArgs e)
        {
            textBox2.Enabled = checkBox1.Checked;
            numericUpDown1.Enabled = checkBox1.Checked;
        }

        private void checkBox3_CheckedChanged_1(object sender, EventArgs e)
        {
            textBox4.Enabled = checkBox3.Checked;
            textBox5.Enabled = checkBox3.Checked;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            vypis = new Form2();
            vypis.Location = new Point(this.Location.X + this.Size.Width, this.Location.Y);
            vypis.Show();
            this.Activate();
            zacatekHry();
        }

        private Point checkPozice(int X, int Y, char smer, bool pozadu)
        {
            if (X > 0 && X < 20 && Y > 0 && Y < 20)
            {
                if (policko[Y - 1, X - 1].BackColor == Color.Brown)
                {
                    if (smer == 'N') if (pozadu) Y -= 1; else Y += 1;
                    if (smer == 'D') if (pozadu) Y += 1; else Y -= 1;
                    if (smer == 'L') if (pozadu) X -= 1; else X += 1;
                    if (smer == 'R') if (pozadu) X += 1; else X -= 1;
                }
                if (policko[Y - 1, X - 1].BackColor == Color.Black)
                {
                    war.Show();
                }
                if (policko[Y - 1, X - 1].BackColor == Color.Yellow)
                {
                    doit.Enabled = true;
                }
            }
            else war.Show();
            return new Point(X, Y);
        }

        private void vyridPohyby()
        {
            int d_poziceX = PoziceLerakaX;
            int d_poziceY = PoziceLerakaY;
            char d_otoceni = SmerLeraka;

            war.Hide();

            doit.Enabled = false;
            bool vsechny = true;

            for (int i = 0; i <= 4; i++)
            {
                if (kartaZ[i].Text == "?")
                {
                    budLerak[i].Hide();
                    vsechny = false;
                }
                else
                {
                    if (kartaZ[i].Text == "1" || kartaZ[i].Text == "2" || kartaZ[i].Text == "3")
                    {
                        int j = Convert.ToInt16(kartaZ[i].Text);
                        for (int a = 1; a <= j; a++)
                        {
                            if (d_otoceni == 'N') d_poziceY -= 1;
                            if (d_otoceni == 'D') d_poziceY += 1;
                            if (d_otoceni == 'L') d_poziceX -= 1;
                            if (d_otoceni == 'R') d_poziceX += 1;
                            Point p = checkPozice(d_poziceX, d_poziceY, d_otoceni, false);
                            d_poziceX = p.X; d_poziceY = p.Y;
                        }
                    }

                    if (kartaZ[i].Text == "L")
                    {
                        if (d_otoceni == 'N') d_otoceni = 'L'; else
                        if (d_otoceni == 'D') d_otoceni = 'R'; else
                        if (d_otoceni == 'L') d_otoceni = 'D'; else
                        if (d_otoceni == 'R') d_otoceni = 'N';
                    }
                    if (kartaZ[i].Text == "R")
                    {
                        if (d_otoceni == 'N') d_otoceni = 'R'; else
                        if (d_otoceni == 'D') d_otoceni = 'L'; else
                        if (d_otoceni == 'L') d_otoceni = 'N'; else
                        if (d_otoceni == 'R') d_otoceni = 'D';
                    }

                    if (kartaZ[i].Text == "Z")
                    {
                        if (d_otoceni == 'N') d_poziceY += 1;
                        if (d_otoceni == 'D') d_poziceY -= 1;
                        if (d_otoceni == 'L') d_poziceX += 1;
                        if (d_otoceni == 'R') d_poziceX -= 1;
                        Point p = checkPozice(d_poziceX, d_poziceY, d_otoceni, true);
                        d_poziceX = p.X; d_poziceY = p.Y;
                    }

                    budLerak[i].Location = new Point((d_poziceX - 1) * 20 + 3, (d_poziceY - 1) * 20 + 3);
                    if (d_otoceni == 'N') budLerak[i].Text = "^";
                    if (d_otoceni == 'D') budLerak[i].Text = "v";
                    if (d_otoceni == 'R') budLerak[i].Text = ">";
                    if (d_otoceni == 'L') budLerak[i].Text = "<";
                    budLerak[i].Show();
                    budLerak[i].BringToFront();
                }
            }

            if (vsechny) doit.Enabled = true;
        }

        private void dp_click(object sender, EventArgs e)
        {
            Label l = sender as Label;
            if (l.BackColor == Color.FromArgb(128, 255, 128) && volnaKarta < 5)
            {
                l.BackColor = Color.FromArgb(255, 192, 128);
                kartaZ[volnaKarta].Text = l.Text;
                kartaZ[volnaKarta].BackColor = Color.FromArgb(255, 255, 128);
                for (int i = 0; i <= 8; i++) if (l == kartaD[i]) zvolenaKarta[volnaKarta] = (byte)i;

                volnaKarta++;
                vyridPohyby();
            }
        }

        private void zp_click(object sender, EventArgs e)
        {
            Label l = sender as Label;
            if (l.BackColor == Color.FromArgb(255, 255, 128))
            {
                int index = 0;
                for (int i = 0; i <= 4; i++) if (l == kartaZ[i]) index = i;

                kartaD[zvolenaKarta[index]].BackColor = Color.FromArgb(128, 255, 128);

                if (index == volnaKarta - 1)
                {
                    kartaZ[index].Text = "?";
                    kartaZ[index].BackColor = Color.FromArgb(192, 192, 255);
                }
                else
                {
                    for (int i = index; i <= volnaKarta - 1; i++)
                    {
                        if (i < 4)
                        {
                            kartaZ[i].Text = kartaZ[i + 1].Text;
                            zvolenaKarta[i] = zvolenaKarta[i + 1];
                        }
                        else
                            kartaZ[i].Text = "?";
                    }
                    kartaZ[volnaKarta - 1].Text = "?";
                    kartaZ[volnaKarta - 1].BackColor = Color.FromArgb(192, 192, 255);
                }


                volnaKarta--;
                vyridPohyby();
            }
        }

        private void doit_Click(object sender, EventArgs e)
        {
            dalsiTah();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            for (int i = 0; i <= 4; i++)
            {
                kartaZ[i].Text = "?";
                kartaZ[i].BackColor = Color.FromArgb(192, 192, 255);
                budLerak[i].Hide();
            }
            volnaKarta = 0;
            zacatekHry();
        }

        private void button5_Click(object sender, EventArgs e)
        {
            Form3 f = new Form3();
            f.ShowDialog();
            int pozX = f.souX;
            int pozY = f.souY;
            char otoc = f.otoc;

            List<char> pohyb = new List<char>();
            for (int i = 0; i <= 8; i++)
                pohyb.Add(Convert.ToChar(kartaD[i].Text));

            MessageBox.Show("Tohle nefunguje...");
        }



    }
}
